config/routes.rb
require 'api_constraints'
RiseRp::Application.routes.draw do
  
  root 'pages#index'  

  get :search, to: 'resources#search'

  resources :collections do
    collection do 
      get :import
    end
    resources :resources, controller: 'collections/resources' do
      collection do
        get :import
      end
    end
  end

  resources :resources do
    resources :sections, controller: 'resources/sections' do
      collection do
        get :import
      end
    end
  end

  resources :sections, controller: 'resources/sections' do
    resources :content_units, controller: 'sections/content_units' do
      collection do
        get :import
      end
    end
  end

  resources :pages do
    collection do
      get :home
      get :help
    end
  end

  namespace :api, defaults: { format: :json } do
    scope module: :v1, constraints: ApiConstraints.new(version: 1, default: true) do
      get :search, param: :q, to: 'resources#search'
      resources :collections, param: :uuid, only: %i{index show} do
        resources :resources, only: %i{index}, controller: 'collections/resources' do
        end
      end
      resources :resources, param: :uuid, only: %i{index show} do
        member do
          get :metadata
        end
        resources :sections, only: %i{index}, controller: 'resources/sections'
      end
      resources :sections, param: :uuid, only: %i{index show} do
        member do
          get :metadata
        end
        resources :content_units, only: %i{index}, controller: 'sections/content_units' do
        end
      end
      resources :content_units, param: :uuid, only: %i{show} do
        member do
          get :metadata
        end
      end
    end
  end
end

app/models/content_unit.rb
# == Schema Information
#
# Table name: content_units
#
#  id          :bigint(8)        not null, primary key
#  section_id  :bigint(8)
#  uuid        :uuid             not null
#  resource_id :bigint(8)
#  metadata    :jsonb
#  name        :string
#  content     :string
#  created_at  :datetime         not null
#  updated_at  :datetime         not null
#

class ContentUnit < ApplicationRecord
  default_scope { order(id: :asc) }
  include UuidFindable
  belongs_to :section, inverse_of: :content_units
  searchkick callbacks: :queue
end

app/models/section.rb
# == Schema Information
#
# Table name: sections
#
#  id          :bigint(8)        not null, primary key
#  resource_id :bigint(8)
#  uuid        :uuid             not null
#  name        :string
#  metadata    :jsonb
#  ancestry    :string
#  is_leaf     :boolean          default(FALSE)
#  created_at  :datetime         not null
#  updated_at  :datetime         not null
#

class Section < ApplicationRecord
  include UuidFindable

  has_ancestry

  belongs_to :resource, inverse_of: :sections
  has_many :content_units, inverse_of: :section, dependent: :destroy

  default_scope { order(name: :asc) }

  def content_unit_count
    content_units.count
  end

  def parent_uuid
    if parent.nil?
      nil
    else
      parent.uuid
    end
  end

end

app/controllers/api/v1/content_units_controller.rb
module Api
  module V1
    class ContentUnitsController < Api::ApiController
      before_action :set_content_unit, only: %i{show metadata}

      def show
        render json: @content_unit
      end

      def metadata
        render json: @content_unit.cascading_metadata.to_json
      end

      private

      def render_errors
        render json: { errors: @content_unit.errors }, status: :unprocessable_entity
      end

      def set_content_unit
        @content_unit = ContentUnit.from_uuid(params[:uuid])
      end
    end
  end
end

app/controllers/api/v1/resources/sections_controller.rb
module Api
  module V1
    module Resources
      class SectionsController < Api::ApiController
        before_action :set_resource, only: %i{index}
        def index
          render json: @resource.sections
        end

        private

        def set_resource
          @resource = Resource.from_uuid(params[:resource_uuid])
        end
      end
    end
  end
end

app/controllers/api/v1/sections/content_units_controller.rb
module Api
  module V1
    module Sections
      class ContentUnitsController < Api::ApiController
        before_action :set_section, only: %i{index docusky_index}

        def index
          render json: @section.content_units
        end

        private

        def set_section
          @section = Section.from_uuid(params[:section_uuid])
        end
      end
    end
  end
end

app/controllers/api/v1/sections_controller.rb
module Api
  module V1
    class SectionsController < Api::ApiController
      before_action :set_section, only: %i{show metadata}

      def show
        render json: @section
      end

      def metadata
        render json: @section.metadata.to_json
      end

      private

      def render_errors
        render json: { errors: @section.errors }, status: :unprocessable_entity
      end

      def set_section
        @section = Section.from_uuid(params[:uuid])
      end
    end
  end
end

app/controllers/resources/sections_controller.rb
module Resources
  class SectionsController < ApplicationController
    before_action :set_resource, only: %i[index edit update import new create destroy]
    before_action :set_section, only: %i[show edit update destroy]
  
    def index
    	@sections = @resource.sections.page params['page']
    end
  
    def import
    end
  
    def show; end
  
    def new
      @section = Section.new
    end
  
    def edit; end
  
    def create
      @section = @resource.sections.build(section_params)
      if @section.save
        redirect_to [@resource, Section], notice: 'Section was successfully created.'
      else
        render :new
      end
    end
  
    def update
      if @section.update(section_params)
        redirect_to [@resource, :sections], notice: 'Section was successfully updated.'
      else
        render :edit
      end
    end
  
    def destroy
      @section.destroy
      redirect_to [@resource, :sections], notice: 'Section deleted'
    end
  
    def set_resource
      @resource = Resource.find(params[:resource_id])
    end

    def set_section
      @section = Section.find(params[:id])
    end
  
    def section_params
      params.fetch(:section, {}).permit(:name, :resource_id, :parent_id)
    end
  end
end

app/controllers/sections/content_units_controller.rb
module Sections
  class ContentUnitsController < ApplicationController
    before_action :set_section, only: %i[index edit update import new create destroy]
    before_action :set_content_unit, only: %i[show edit update destroy]
  
    def index
    	@content_units = @section.content_units.page params['page']
    end
  
    def import
    end
  
    def show; end
  
    def new
      @content_unit = ContentUnit.new
    end
  
    def edit; end
  
    def create
      @content_unit = @section.content_units.build(content_unit_params)
      if @content_unit.save
        redirect_to [@section, ContentUnit], notice: 'Content Unit was successfully created.'
      else
        render :new
      end
    end
  
    def update
      if @content_unit.update(content_unit_params)
        redirect_to [@section, :content_units], notice: 'Content Unit was successfully updated.'
      else
        render :edit
      end
    end
  
    def destroy
      @content_unit.destroy
      redirect_to [@section, :content_units], notice: 'ContentUnit deleted'
    end
  
    def set_section
      @section = Section.find(params[:section_id])
    end

    def set_content_unit
      @content_unit = ContentUnit.find(params[:id])
    end
  
    def content_unit_params
      params.fetch(:content_unit, {}).permit(:name, :content)
    end
  end
end

app/views/sections/content_units/_form.html.haml
= simple_form_for([@section, @content_unit]) do |f|
  = f.error_notification
  = f.input :name
  = f.input :content
  = f.button :button, type: :submit, class: 'btn btn-primary'

app/views/sections/content_units/edit.html.haml
.d-flex.justify-content-between.flex-wrap.flex-md-nowrap.align-items-center.pb-2.mb-3
  %h1.h2 Edit Content Unit
= render 'form'

app/views/sections/content_units/index.html.haml
.d-flex.justify-content-between.flex-wrap.flex-md-nowrap.align-items-center.pb-2.mb-3
  %h1.h4 #{link_to truncate(@section.resource.collection.name, length: 20), [@section.resource.collection, Resource]} > #{link_to truncate(@section.resource.name, length: 20), [@section.resource, Section]} > #{link_to truncate(@section.name, length: 20), [@section, ContentUnit]} > Content Units
  .btn-toolbar.mb-2.mb-md-0
    .btn-group.mr-2
      = link_to new_section_content_unit_path(@section), class: 'btn btn-sm btn-outline-secondary' do
        %span{"data-feather" => "plus"}
        New Content Unit
      = link_to import_section_content_units_path(@section), class: 'btn btn-sm btn-outline-secondary' do 
        %span{"data-feather" => "upload"}
        Import Content Units
.table-responsive
  %table.table.table-striped.table-sm
    %thead
      %tr
        %th uuid
        %th Name
        %th Content
        %th Metadata
        %th Actions
    %tbody
      - @content_units.each do |content_unit|
        %tr
          %td= content_unit.uuid
          %td= content_unit.name
          %td= content_unit.content
          %td= content_unit.metadata
          %td
            .btn-group-vertical
              = link_to edit_section_content_unit_path(id: content_unit.id, section_id: @section.id), class: 'btn btn-sm btn-outline-secondary' do
                %span{"data-feather" => "edit"}
                Edit
              = link_to section_content_unit_path(id: content_unit.id, section_id: @section.id), method: :delete, class: 'btn btn-sm btn-outline-secondary' do 
                %span{"data-feather" => "x-circle"}
                Delete

= paginate @content_units, theme: 'twitter-bootstrap-4'

app/views/sections/content_units/new.html.haml
.d-flex.justify-content-between.flex-wrap.flex-md-nowrap.align-items-center.pb-2.mb-3
  %h1.h2 New Content Unit for Section #{@section.name}
= render 'form'